﻿Imports Infragistics.Win

Public Class Form1

    Private Sub CmdPrintCRLF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdPrintCRLF.Click
        Dim vCls As New clsGridReport
        Try
            Dim vReturnStr As clsGridReport.LineSeparator = clsGridReport.LineSeparator.CRLF
            If RdoCR.Checked Then
                vReturnStr = clsGridReport.LineSeparator.CR
            ElseIf RdoLF.Checked Then
                vReturnStr = clsGridReport.LineSeparator.LF
            End If
            vCls.PrintTest(Me, vReturnStr, UseEditor, PadString, MaxLength, ColumnStyle)
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            vCls = Nothing
        End Try
    End Sub

    Friend Sub SetDataSource(ByRef vTable As DataTable)
        UgRpt.DataSource = Nothing
        UgRpt.DataSource = vTable
        Dim i As Integer = 0
        For i = 0 To UgRpt.Rows.Band.Columns.Count - 1
            If UgRpt.Rows.Band.Columns(i).ToString = "Status" OrElse UgRpt.Rows.Band.Columns(i).ToString = "Code" Then
                UgRpt.Rows.Band.Columns(i).Width = 55
            Else
                UgRpt.Rows.Band.Columns(i).Width = 200
            End If
        Next
        With UgRpt.Rows.Band.Header.Appearance
            .FontData.Bold = Infragistics.Win.DefaultableBoolean.True
            .BorderAlpha = Infragistics.Win.Alpha.Transparent
            .BorderColor = Color.White
            .BackColor = Color.White
            .BackColor2 = Color.White
            .BackColorAlpha = Infragistics.Win.Alpha.Transparent
            .TextHAlign = Infragistics.Win.HAlign.Center
        End With
        With UgRpt.Rows.Band.Override.CellAppearance
            .BorderColor = Color.White
            .BorderColor2 = Color.White
            .BorderAlpha = Infragistics.Win.Alpha.Transparent
        End With
        With UgRpt.Rows.Band.Override.RowAppearance
            .BorderAlpha = Infragistics.Win.Alpha.Transparent
            .BorderColor = Color.White
            .BorderColor2 = Color.White
        End With
        UgRpt.Rows.Band.HeaderVisible = True
    End Sub

    Friend ReadOnly Property PadString As String
        Get
            Dim vRet As String = "M"
            If TxtPadPhrase.Text.Length > 0 Then
                vRet = TxtPadPhrase.Text & ""
            End If
            Return vRet
        End Get
    End Property

    Friend ReadOnly Property MaxLength As Integer
        Get
            Dim vRet As Integer = 34290
            If TxtMaxLength.Text.Length > 0 AndAlso IsNumeric(TxtMaxLength.Text) Then
                vRet = CInt(TxtMaxLength.Text)
            End If
            Return vRet
        End Get
    End Property

    Friend ReadOnly Property ColumnStyle As UltraWinGrid.ColumnStyle
        Get
            Dim vRet As UltraWinGrid.ColumnStyle = UltraWinGrid.ColumnStyle.Default
            If RdoFT.Checked Then
                vRet = UltraWinGrid.ColumnStyle.FormattedText
            ElseIf RdoFTE.Checked Then
                vRet = UltraWinGrid.ColumnStyle.FormattedTextEditor
            End If
            Return vRet
        End Get
    End Property

    Friend ReadOnly Property UseEditor As Boolean
        Get
            Return ChkUseEditor.Checked
        End Get
    End Property
End Class
