﻿Imports Infragistics
Imports Infragistics.Win
Public Class clsGridReport
    Private cPDoc As Infragistics.Win.UltraWinGrid.UltraGridPrintDocument = Nothing
    Private cPDlg As Infragistics.Win.Printing.UltraPrintPreviewDialog = Nothing

    Friend Enum LineSeparator
        CRLF = 0
        CR = 1
        LF = 2
    End Enum

    Friend Sub PrintTest(ByRef vForm As Form1, ByVal NewLineDef As LineSeparator, ByVal UseEditor As Boolean, ByVal PadPhrase As String, ByVal MaxLength As Integer, ByVal ColumnStyle As UltraWinGrid.ColumnStyle)
        Dim vRel As New DataSet
        Dim vRow As DataRow = Nothing
        Dim vNotes As New DataTable
        Try
            vNotes.Columns.Add("ID", GetType(System.Int32))
            vNotes.Columns.Add("TestNote", GetType(System.String))
            Dim vStr As String = ""
            Dim i As Integer = 0
            Do While i < MaxLength
                vStr = vStr & PadPhrase
                Dim n As Integer = 50
                If i >= n Then
                    'I'm deliberately adding two instances so that it is easy to 
                    'see the difference; adding just one results in the same basic behavior.
                    Select Case NewLineDef
                        Case LineSeparator.CRLF
                            vStr = vStr & vbCrLf & vbCrLf
                        Case LineSeparator.CR
                            vStr = vStr & vbCr & vbCr
                        Case Else
                            vStr = vStr & vbLf & vbLf
                    End Select
                    n = vStr.Length + 50
                End If
                i = vStr.Length
            Loop
            'Cut off at MaxLength (cheap and awful approach)
            If vStr.Length > MaxLength Then
                vStr = Microsoft.VisualBasic.Left(vStr, MaxLength)
            End If
            vRow = vNotes.NewRow
            vRow.Item("TestNote") = vStr
            vRow.Item("ID") = 1
            vNotes.Rows.Add(vRow)
            vNotes.TableName = "NotePad"
            vRel.Tables.Add(vNotes)
            'set datasource: It is a bit silly to go to the form for this, but it seems to be the cheapest way to get 
            'some of the initialization code for the grid to fire for a test case
            vForm.SetDataSource(vNotes)
            If cPDoc Is Nothing Then
                cPDoc = New UltraWinGrid.UltraGridPrintDocument
            End If
            If cPDlg Is Nothing Then
                cPDlg = New Printing.UltraPrintPreviewDialog
            End If
            With cPDoc
                .DocumentName = "Test"
                .Header.TextCenter = "Test"
                .Grid = vForm.UgRpt
                .Grid.DisplayLayout.BorderStyle = UIElementBorderStyle.None
                .Grid.Rows.ExpandAll(True)
                .Grid.Dock = DockStyle.Fill
                .Header.Padding.Bottom = 10
                .FitWidthToPages = 1
            End With
            With cPDoc.Grid.DisplayLayout
                .Bands(0).Override.RowSizing = UltraWinGrid.RowSizing.AutoFree
                .Bands(0).Columns("ID").Hidden = True
                .Bands(0).Columns("TestNote").Width = 800
                If UseEditor Then
                    Dim vEdit As New UltraWinEditors.UltraTextEditor
                    .Bands(0).Columns("TestNote").EditorComponent = vEdit
                    'Do not dispose, just clean up variable reference
                    vEdit = Nothing
                End If
                .Bands(0).Columns("TestNote").Style = ColumnStyle
                .Bands(0).Columns("TestNote").CellMultiLine = DefaultableBoolean.True
            End With
            With cPDlg
                .Document = cPDoc
                .PerformAutoScale()
                .DisplayPreviewStatus = True
                .ThumbnailAreaVisible = False
                .AutoGeneratePreview = True
                .ShowDialog()
            End With
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            If vRel IsNot Nothing Then
                vRel.Dispose()
                vRel = Nothing
            End If
            vRow = Nothing
            If vNotes IsNot Nothing Then
                vNotes.Dispose()
                vNotes = Nothing
            End If
            If cPDlg IsNot Nothing AndAlso Not cPDlg.IsDisposed Then
                cPDlg.Dispose()
            End If
            cPDlg = Nothing
            If cPDoc IsNot Nothing Then
                cPDoc.Dispose()
                cPDoc = Nothing
            End If
        End Try
    End Sub
End Class
